# TODO:
# - make some README.PLD with system features description
#
%bcond_without	diet		# compile binaries with diet cc

%define	iana_etc_ver	2.30
Summary:	Simple setup files
Summary(de.UTF-8):	Einfache Setup-Dateien
Summary(es.UTF-8):	Varios archivos básicos de configuración
Summary(fr.UTF-8):	Fichiers de configuration simples
Summary(ja.UTF-8):	サンプルセットアップファイル
Summary(pl.UTF-8):	Podstawowe pliki systemu Linux
Summary(pt_BR.UTF-8):	Vários arquivos básicos de configuração
Summary(tr.UTF-8):	Basit kurulum dosyaları
Name:		setup
Version:	2.10.0
Release:	1
License:	Public Domain, partially BSD-like
Group:		Base
Source0:	%{name}-%{version}.tar.bz2
# Source0-md5:	1ecb6d9865ce3300881fa466d0c97583
# http://sethwklein.net/iana-etc
Source1:	http://sethwklein.net/projects/iana-etc/downloads/iana-etc-%{iana_etc_ver}.tar.bz2
# Source1-md5:	3ba3afb1d1b261383d247f46cb135ee8
Source2:	http://www.iana.org/assignments/protocol-numbers/index.txt
# Source2-md5:	33440b7d913303a6051ae64290f0ab21
Source3:	http://www.iana.org/assignments/port-numbers
# Source3-md5:	8e19a2c7cf60baabf919de1cc89a1cbb
Patch0:		%{name}-iana-etc.patch
# This is source of non-iana changes in services file
Patch1:		%{name}-services.patch
Patch2:		protocols-fmt.patch
%if %{with diet}
BuildRequires:	dietlibc-static
%else
BuildRequires:	glibc-static
%endif
BuildRequires:	gawk
BuildRequires:	glibc-misc
Requires:	FHS >= 2.3-24.1
Provides:	group(fuse)
Conflicts:	PowerChutePlus < 4.5.3-2
Conflicts:	glibc < 6:2.4-4.1
# tape,dialout and cdrom groups support
Conflicts:	dev < 3.4-4
Conflicts:	udev < 1:138-5
# /etc/mtab being symlink to /proc/self/mounts
Conflicts:	rc-scripts < 0.4.5.1-3
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sbindir	/sbin
%undefine	with_ccache

%ifnarch x32
# not on x32, see 02e9d04
%define		specflags -Os
%endif

%description
This package contains a number of very important configuration and
setup files, including the passwd, group, profile files, etc.

%description -l de.UTF-8
Dieses Paket enthält wichtige Konfigurations- und Setup-Dateien, u.a.
passwd-, group-, profile-Dateien usw.

%description -l es.UTF-8
Este paquete contiene una variedad de archivos de configuración y
setup muy importantes, incluyendo el passwd, group, archivos de
"perfil", etc.

%description -l fr.UTF-8
Ce paquetage contient un nombre de fichiers de configuration très
importants, comme passwd, group, les fichiers profile, etc.

%description -l ja.UTF-8
このsetupパッケージには、passwd, group, profile などの、
重要なシステム設定ファイルが含まれてます。

%description -l pl.UTF-8
Pakiet ten zawiera wiele bardzo ważnych plików konfiguracyjnych dla
Twojego systemu.

%description -l pt_BR.UTF-8
Este pacote contém uma variedade de arquivos de configuração e setup
muito importantes, incluindo o passwd, group, arquivos de "perfil",
etc.

%description -l tr.UTF-8
Bu paket, passwd, group, profile gibi çok önemli ayar ve kurulum
dosyalarını içerir.

%prep
%setup -q -a1
mv iana-etc{-%{iana_etc_ver},}
%patch0 -p1
%patch2 -p1

cp -p %{SOURCE2} iana-etc/protocol-numbers.iana
cp -p %{SOURCE3} iana-etc/port-numbers.iana

%build
%{__make} -C iana-etc
%{__patch} iana-etc/services %{PATCH1}

# kill trailing spaces/tabs
%{__sed} -i -e 's,[ \t]\+$,,' iana-etc/{services,protocols}

%{__make} \
	CC="%{?with_diet:diet }%{__cc}" \
	OPT_FLAGS="%{rpmcflags} -D_LARGEFILE_SOURCE=1 -D_FILE_OFFSET_BITS=64" \
	LDFLAGS="%{rpmcflags} %{rpmldflags} -static"

ldd postshell | grep "not a dynamic executable" || exit 1

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_sysconfdir}/shrc.d
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

cp -p iana-etc/{services,protocols} $RPM_BUILD_ROOT%{_sysconfdir}

# not packaged
%{__rm} $RPM_BUILD_ROOT%{_sysconfdir}/{netgroup,suid_profile}

%clean
rm -rf $RPM_BUILD_ROOT

# trigger to ensure /etc/mtab is symlink
%triggerprein -p /sbin/postshell -- %{name} < %{version}-%{release}
-/bin/sh -c '/usr/bin/test -L /etc/mtab || /bin/mv -v /etc/mtab /etc/mtab.rpmsave'

%triggerpostun -p /sbin/postshell -- %{name} < %{version}-%{release}
%{_sbindir}/joinpasswd
%{_sbindir}/delpasswd -g ttyS cdwrite

%triggerin -p %{_sbindir}/update-fstab -- %{name} < 2.4.10-1

%post -p /sbin/postshell
-/sbin/env-update -u

%postun -p /sbin/postshell
-/sbin/env-update -u

%files
%defattr(644,root,root,755)
%doc ChangeLog
%attr(755,root,root) %{_sbindir}/delpasswd
%attr(755,root,root) %{_sbindir}/joinpasswd
%attr(755,root,root) %{_sbindir}/postshell
%attr(755,root,root) %{_sbindir}/update-fstab
%dir /etc/profile.d
%config(noreplace,missingok) %verify(not md5 mtime size) %attr(755,root,root) /etc/profile.d/00-tmp-dir.sh
%config(noreplace,missingok) %verify(not md5 mtime size) %attr(755,root,root) /etc/profile.d/00-tmp-dir.csh
%dir %{_sysconfdir}/env.d
%config(noreplace,missingok) %verify(not md5 mtime size) %{_sysconfdir}/env.d/EDITOR
%config(noreplace,missingok) %verify(not md5 mtime size) %{_sysconfdir}/env.d/HISTFILESIZE
%config(noreplace,missingok) %verify(not md5 mtime size) %{_sysconfdir}/env.d/HOME_ETC
%config(noreplace,missingok) %verify(not md5 mtime size) %{_sysconfdir}/env.d/MAILCHECK
%config(noreplace,missingok) %verify(not md5 mtime size) %{_sysconfdir}/env.d/MAILPATH
%config(noreplace,missingok) %verify(not md5 mtime size) %{_sysconfdir}/env.d/NNTPSERVER
%config(noreplace,missingok) %verify(not md5 mtime size) %{_sysconfdir}/env.d/ORGANIZATION
%config(noreplace,missingok) %verify(not md5 mtime size) %{_sysconfdir}/env.d/TMOUT
%config(noreplace,missingok) %verify(not md5 mtime size) %{_sysconfdir}/env.d/VISUAL
%dir %{_sysconfdir}/shrc.d
%config(noreplace) %verify(not md5 mtime size) /etc/shrc.d/256term.sh
%config(noreplace) %verify(not md5 mtime size) /etc/shrc.d/256term.csh
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/fstab
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/group
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/host.conf
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/hosts
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/passwd
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/profile
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/protocols
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/subgid
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/subuid
%attr(600,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/securetty
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/services
%config(noreplace,missingok) %verify(not md5 mtime size) %{_sysconfdir}/filesystems
%config(noreplace,missingok) %verify(not md5 mtime size) %{_sysconfdir}/motd
%config(noreplace,missingok) %verify(not md5 mtime size) %{_sysconfdir}/resolv.conf
%ghost %{_sysconfdir}/shells
# symlink to /proc/self/mounts
%{_sysconfdir}/mtab


%changelog
* Wed Jan 16 2019 TLD Linux <feedback@tld-linux.org>
- For complete changelog see: http://git.tld-linux.org/?p=packages/setup.git;a=log;h=master

* Tue Nov 20 2018 Elan Ruusamäe <glen@pld-linux.org> 1244ac5
- up to 2.10.0; sub[ug]ids added

* Wed Oct 03 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 9bee86e
- rel 5; rename tmp-dir profile.d scripts, so these will be processed before all other profile.d scripts (so for example ssh-agent will get proper tmp dir)

* Sat May 02 2015 Elan Ruusamäe <glen@delfi.ee> ba72583
- move -Os to specflags

* Fri May 01 2015 Jan Rękorajski <baggins@pld-linux.org> 02e9d04
- drop -Os, it's not much gain and causes diet to miscompile on x32
- rel 4

* Mon Apr 20 2015 Jacek Konieczny <j.konieczny@eggsoft.pl> 414bf70
- 'input' group added

* Tue Feb 24 2015 Jan Rękorajski <baggins@pld-linux.org> afce3f9
- x32 rebuild
- release 2 (by relup.sh)

* Sun Feb 09 2014 Jan Rękorajski <baggins@pld-linux.org> 391e894
- updated to 2.9.0 with spoort for 256 colors terminals enabled

* Sun Sep 15 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 95033f1
- rel 5; always enable largefile

* Wed Jun 19 2013 Jan Rękorajski <baggins@pld-linux.org> ea17a59
- build with diet, those binaries must be static and linking with glibc
  makes them huge
- rel 4

* Tue Jun 18 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 00ef0f6
- glibc-misc BR shouldn't be conditional

* Tue Jun 18 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> a44db04
- BR glibc-misc for ldd

* Tue Jun 18 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 3aa38c7
- rel 3; make sure it is built statically

* Tue Jun 18 2013 Elan Ruusamäe <glen@delfi.ee> c06b68d
- preserve /etc/mtab as rpmsave if it was file

* Fri May 31 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> a0098a5
- up to 2.8.5; link with glibc (only 3k bigger in > 700k package) to be more reliable

* Tue Jul 10 2012 Marcin Krol <hawk@tld-linux.org> f487bc1
- release 2

* Wed Apr 04 2012 Jakub Bogusz <qboosh@pld-linux.org> ea53b03
- use __rm macro, verbose profile.d and env.d files

* Sun Jan 29 2012 Jan Rękorajski <baggins@pld-linux.org> 5ed6243
- 2.8.4

* Thu Jan 12 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> cc08296
- md5

* Thu Jan 12 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 8d64dd5
- 2.8.3 ; hidepid=2 for /proc

* Thu Dec 08 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> 20e1b4f
- up to 2.8.2

